﻿// Button_Group Class -- last edited 102108

package com.webdevils {
    import flash.events.*;
    import flash.display.*;

    public class Button_Group {
        private var button_array:Array;
        private var selected_button;
        private var disabled_string:String;

        // ------------------------- Constructor --------------------------
        public function Button_Group( _array:Array, _select:int = -1, _disabled:String = "disabled" ) {
            button_array = _array;
            disabled_string = _disabled;
            init_group();
            if ( _select > -1 ) {
                selected_button = _select;
                select_button( selected_button );
            }                  
        }
       
        // ------------------------ Private Methods -----------------------
        private function init_group():void {
            for ( var i = 0; i < button_array.length; i++ ) {
                button_array[i].stop();
                button_array[i].mouseChildren = false;
                button_array[i].buttonMode = true;
                button_array[i].addEventListener( MouseEvent.CLICK, on_click );
            }
        }
       
        private function on_click( e:MouseEvent ):void {
            if ( selected_button != -1 ) {
                deselect_button( selected_button );
            }
            disable_button_by_reference( e.currentTarget );
        }
       
        private function select_button( _index:uint ):void {
            button_array[ _index ].mouseEnabled = false;
            button_array[ _index ].buttonMode = false;
            button_array[ _index ].gotoAndStop( disabled_string );
        }
       
        private function deselect_button( _index:uint ):void { 
            button_array[ _index ].gotoAndStop( "_up" );
            button_array[ _index ].mouseEnabled = true;
            button_array[ _index ].buttonMode = true;
        }
       
        // ---------------------- Public Methods -----------------------------
        public function enable_all_buttons():void {
            for ( var i = 0; i < button_array.length; i++ ) {
                deselect_button( i );
            }
            selected_button = -1;
        }
       
        public function disable_all_buttons():void {
            for ( var i = 0; i < button_array.length; i++ ) {
                select_button( i );
            }
            selected_button = -1;
        }
       
        public function disable_button_by_index( _index:uint, _deselect:Boolean = true ):void {
            if ( _deselect ) {
                deselect_button( selected_button );
            }
            selected_button = _index;
            select_button( selected_button );
        }
       
        public function disable_button_by_reference( _mc, _deselect:Boolean = true ):void {
            if ( _deselect && selected_button > -1 ) {
                deselect_button( selected_button );
            }
            for ( var i = 0; i < button_array.length; i++ ) {
                if ( button_array[i] == _mc ) {
                    selected_button = i;
                    select_button( selected_button );
                    break;
                }
            }
        }
       
        public function enable_button_by_index( _index:uint ):void {
            if ( selected_button == _index ) {
                selected_button = -1;
            }
            deselect_button( selected_button );
        }
       
        public function enable_button_by_reference( _mc ):void {
            for ( var i = 0; i < button_array.length; i++ ) {
                if ( button_array[i] == _mc ) {
                    if ( selected_button == i ) {
                        selected_button = -1;
                    }
                    deselect_button( selected_button );
                    break;
                }
            }
        }
    }
}