﻿package com.webdevils {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import caurina.transitions.Tweener;
	
	public class Load_Content extends EventDispatcher {
		public var current_content:Loader;
		
		private var host_mc:MovieClip;
		
		private var old_content:Array;
		private var open_tween:Object;	// Object to hold the tween that introduce a new clip
		private var exit_tween:Object;	// Object to hold tween that exits a clip
		private var starting_values:Object;
		
		public function Load_Content( _mc:MovieClip, o_tween:Object, c_tween:Object, start_obj:Object ) {
			host_mc = _mc;
			old_content = new Array();
			open_tween = o_tween;					
			exit_tween = c_tween;
			exit_tween.onComplete = remove_content; // Make sure to add the onComplete call to remove_content
			
			starting_values = start_obj;
		}
		
		public function set_open_tween( _obj:Object ):void {
			open_tween = _obj;
		}
		
		public function set_close_tween( _obj:Object ):void {
			exit_tween = _obj;
		}
		
		public function set_start_obj( _obj:Object ):void {
			starting_values = _obj;
		}
		
		public function add_content( url:String ):Loader {
			// Check for old content and move it off the stage
			if ( current_content != null ) {
				exit_tween.onCompleteParams = [ current_content ];
                Tweener.addTween( current_content, exit_tween );
				/****************************************************************************************/
				// Problem if a clip is loaded before the last completes. Must remove listeners for clips
				// that will be removed from the stage. 
				current_content.contentLoaderInfo.removeEventListener( Event.INIT, on_init );
				current_content.contentLoaderInfo.removeEventListener( ProgressEvent.PROGRESS, on_progress );
				current_content.contentLoaderInfo.removeEventListener( HTTPStatusEvent.HTTP_STATUS, on_http );
				current_content.contentLoaderInfo.removeEventListener( Event.COMPLETE, on_complete );
				current_content.contentLoaderInfo.removeEventListener( IOErrorEvent.IO_ERROR, on_ioerror );
				current_content.contentLoaderInfo.removeEventListener( Event.OPEN, on_open );
				current_content.contentLoaderInfo.removeEventListener( Event.UNLOAD, on_unload );
				/****************************************************************************************/
			} 
			
			
			
			// Create a new loader and start loading
			current_content = new Loader();
			current_content.contentLoaderInfo.addEventListener( Event.INIT, on_init );
			current_content.contentLoaderInfo.addEventListener( ProgressEvent.PROGRESS, on_progress );
			current_content.contentLoaderInfo.addEventListener( HTTPStatusEvent.HTTP_STATUS, on_http );
			current_content.contentLoaderInfo.addEventListener( Event.COMPLETE, on_complete );
			current_content.contentLoaderInfo.addEventListener( IOErrorEvent.IO_ERROR, on_ioerror );
			current_content.contentLoaderInfo.addEventListener( Event.OPEN, on_open );
			current_content.contentLoaderInfo.addEventListener( Event.UNLOAD, on_unload );
			
			current_content.load( new URLRequest( url ) );
			
			dispatchEvent( new  Event( "start" ) );
			
			return current_content;
		}
		
		/*******************************************************************************/
		// Loader Event Handlers 
		private function on_unload( e:Event ):void {
			trace( "Un load" );
		}
		
		private function on_open( e:Event ):void {
			trace( "Open" );
		}
		
		private function on_ioerror( e:IOErrorEvent ):void {
			trace( e.toString() );
		}
		
		private function on_http( e:HTTPStatusEvent ):void {
			trace( "http status" );
		}
		
		private function on_init( e:Event ):void {
			dispatchEvent( new Event( Event.INIT ) );
		}
		
		private function on_progress( e:ProgressEvent ):void {
			dispatchEvent( new ProgressEvent( ProgressEvent.PROGRESS, false, false, e.bytesLoaded, e.bytesTotal ) );
		}
		
		private function on_complete( e:Event ):void {
			for ( var p in starting_values ) {
				current_content[ p ] = starting_values[ p ];
			}
			Tweener.addTween( current_content, open_tween );
			host_mc.addChild( current_content );
			
			current_content.contentLoaderInfo.removeEventListener( ProgressEvent.PROGRESS, on_progress );
			current_content.contentLoaderInfo.removeEventListener( Event.COMPLETE, on_complete );
		}
		
		
		private function remove_content( _mc ):void {
            host_mc.removeChild( _mc );
        }
	}
}